<?php
    require_once 'hos_lib.php';
    hos_log_script_access (__FILE__, $_GET);
    set_root ();
            
    $ok   = true;
    $done = false;
    
    if (false === hos_ctrl_check ()) {
		hos_ctrl_clear();
        if (false === set_root () ||
            false === ($_SESSION ['hos']['ctrl']['activity'] = hos_ctrl_get_activity ()) || 
            false === ($tasks = hos_ctrl_task_from_cfg ()) ||
            false === hos_ctrl_compile ($tasks)) {
			$ok = false;                
        }
        if ($ok) {
	        $save_point = false;        
	        if (hwm_get_inspect () != 1) {        
	            if (false === hos_check_point ($save_point) || $save_point && false === hos_load_point ()) 
	            	$ok = false;
	        }        	        
	        if ($ok)
		        hos_ctrl_register ();
        }           
    }        
    
    if ($ok) {
	    if (false === hos_ctrl_done ($done)) 
	    	$ok = false;	                
    }     
    	
    if ($ok && !$done) {
	    $task_name = hos_ctrl_select_first_task ();        
    	if ($task_name === false)
    		$ok = false;
    
	    else 
	    	$ok = hos_ctrl_run_task_silent ($task_name); 
    }
    
	save_error ($ok);        
	    
    // when the last task of the task list was OK code task
    //
    hos_ctrl_clear();
    
//------------------------------

    function set_root () {
    	if (isset ($_GET ['root']))
    		$_SESSION ['hos']['root'] = $_GET ['root'];
    	return true;
    }
  
    function save_error ($ok) {
    	global $wai_last_errors;

		$path  = hwm_get_process()."/".
		         hwm_get_step()."/".
		         "DMY/0/DMY/PROCMAN MESSAGES";
    	
		if (hwm_file_exists('LOG', 'DMY', $path))
			hwm_delete_file('LOG', 'DMY', $path);
    	
    	if (isset ($wai_last_errors) && isset ($wai_last_errors ['time']) && count ($wai_last_errors ['time']) > 0) {
			$x = '';
			for ($i = 0; $i < count ($wai_last_errors ['time']); $i++) {
				$str = $wai_last_errors ['heading'][$i].' - '. $wai_last_errors ['time'][$i]."\n".
				       $wai_last_errors ['script'][$i].' at line '. $wai_last_errors ['line'][$i]."\n".
				       $wai_last_errors ['message'][$i]."\n\n";
				$x .= $str;
			}
			
		    hwm_add_file_version_from_string (
		        'LOG', 
		        'DMY',
		        $path,
		        $_SESSION ['hwm_context']['process_id'],
		        $_SESSION ['hwm_context']['step_id'],
		        hwm_get_substep (),
		        wai_get_text('Messages from the automation activity'),
		        '',
		        $x);    			        	    		
    	}
    	if (!$ok) {
	        hwm_autoexec_frame_set_error(hwi_translate('ErrorInAutoexecAct'));
        	hwm_add_process_memo(hwm_get_process(), wai_get_text('AutoActFailed'));
        	hwm_set_return_code (hwm_get_step (), 'Error');
        	return false;
    	}
    	else {
            if (!hos_get_flag('reject_auto_done'))
            	hwm_set_return_code (hwm_get_step (), '0');
    	}
    }
?>
